//+------------------------------------------------------------------+
//This indicator is built to fit my trading idea.
//It was based on mix of 2 other indicators:
// 1) MaxMin indicator, made by Cmillion
// 2) Market Statistics v6.0 Drag, made by Akif TOKUZ, mod. by Brooky-Indicators.com
//fareastol
//+------------------------------------------------------------------+

#property indicator_chart_window
//--------------------------------------------------------------------
extern string  IndiName = "MaxMin 1";
extern int     RangePoint = 20;
extern double  daysBack=1;
extern bool    UseManualDrag=true; 
extern color   cMax = LightSkyBlue;
extern color   cMin = LightSalmon;
extern color   cMid = Gray;

double PVP[];
double RangeSize;
double OpenTime = 0;
int    Bars_Back = 0;
int    FindStartIndex()
{
  if (Bars>=Bars_Back) return(Bars_Back);  
  return(0);
} 
//--------------------------------------------------------------------
int init()
{
   //Convert RangePoint to RangeSize;
   RangeSize = RangePoint*Point; if(Digits==3 || Digits==5) RangeSize *=10;

   //Determine reference point Bars_Back for first launch of indicator;
   if(ObjectFind(IndiName+"Starting_Time")==0 && UseManualDrag)
   {     Bars_Back = iBarShift(NULL,0,ObjectGet(IndiName+"Starting_Time", OBJPROP_TIME1));   }
   else  Bars_Back = 1440*daysBack/Period();
   
   return(0);
}
//--------------------------------------------------------------------
int deinit()
{
   ObjectDelete(IndiName+"Max");
   ObjectDelete(IndiName+"Min");
   ObjectDelete(IndiName+"Mid");
   ObjectDelete(IndiName+"Max1");
   ObjectDelete(IndiName+"Min1");
   ObjectDelete(IndiName+"Mid1");
   ObjectDelete(IndiName+"TXT");
   ObjectDelete(IndiName+"Starting_Time");
}
//--------------------------------------------------------------------
int start()
{
   double RangeMax, RangeMin, RangeMid;
   RangeMax = EMPTY_VALUE;
   RangeMin = EMPTY_VALUE;
   RangeMid = EMPTY_VALUE;
   
   double Max = iHigh(NULL,0,iHighest(NULL,0,MODE_HIGH,12,0)); //NumBar 12 to find temporary border of range, idea from zigzag(12/5/3)
   double Min = iLow(NULL,0,iLowest(NULL,0,MODE_LOW,12,0)); 
   
   if(Max > RangeMax)
   {
      RangeMax = Max;
      RangeMin = Max - RangeSize;
      RangeMid = (RangeMax + RangeMin)/2;
   }
   if(Min < RangeMin)
   {
      RangeMin = Min;
      RangeMax = Min + RangeSize;
      RangeMid = (RangeMax + RangeMin)/2;
   }
   
   int CountRangeBar;
   
   OpenTime = Time[0];
      if(ObjectFind(IndiName+"Starting_Time")==0 && UseManualDrag)
      {     Bars_Back= iBarShift(NULL,0,ObjectGet(IndiName+"Starting_Time", OBJPROP_TIME1));      }
      if(ObjectFind(IndiName+"Starting_Time")==0 && !UseManualDrag)
      {     Bars_Back=FindStartIndex();      }
      if(ObjectFind(IndiName+"Starting_Time")!=0)
      {     Bars_Back=FindStartIndex();
            if (Bars_Back!=0)
            { 
               ObjectCreate(IndiName+"Starting_Time", OBJ_VLINE, 0, Time[Bars_Back], 0);
               ObjectSet(IndiName+"Starting_Time", OBJPROP_TIME1, Time[Bars_Back]);
               ObjectSet(IndiName+"Starting_Time", OBJPROP_COLOR, Red); 
               ObjectSet(IndiName+"Starting_Time", OBJPROP_WIDTH, 2);     
            }
      }      
   
   for (int i = Bars_Back; i>=1; i--)
      {
         if (Close[i]<RangeMax && Close[i]>RangeMin) CountRangeBar+=1;
      }
   
   TREND(IndiName+"Max1",Time[Bars_Back],RangeMax,Time[0],RangeMax,cMax,0,1);                     
   TREND(IndiName+"Min1",Time[Bars_Back],RangeMin,Time[0],RangeMin,cMin,0,1);                     
   TREND(IndiName+"Mid1",Time[Bars_Back],RangeMid,Time[0],RangeMid,cMid,0,1);                     
   
   ARROW(IndiName+"Max",Time[0],RangeMax,cMax,6);                     
   ARROW(IndiName+"Min",Time[0],RangeMin,cMin,6);                     
   ARROW(IndiName+"Mid",Time[0],RangeMid,cMid,6);
   
   string RangeInfo = "NumBar "+DoubleToStr(Bars_Back,0)+" / RangeSize "+DoubleToStr(RangePoint,0)+" / Bars in Range "+DoubleToStr(CountRangeBar,0);
   TEXT (IndiName+"TXT",Time[Bars_Back/2],RangeMax, RangeInfo, 7, cMid);                   
   
   return(0);
}
//--------------------------------------------------------------------
void TEXT(string name, datetime T1, double P1, string text, int fonsize, color C)
{
   ObjectDelete(name);                     
   ObjectCreate(name,OBJ_TEXT,0,0,0);                     
   ObjectSet   (name,OBJPROP_TIME1, T1);
   ObjectSet   (name,OBJPROP_PRICE1, P1);
   ObjectSetText(name, text, fonsize, "Arial", C);
}
//--------------------------------------------------------------------
void ARROW(string name, datetime T1, double P1, color C, int ARROWCODE)
{
   ObjectDelete(name);                     
   ObjectCreate(name,OBJ_ARROW,0,T1,P1,0,0,0,0);                     
   ObjectSet   (name,OBJPROP_ARROWCODE,ARROWCODE);
   ObjectSet   (name,OBJPROP_COLOR, C);
}
//--------------------------------------------------------------------+
void TREND(string name, datetime T1, double P1, datetime T2, double P2, color C, int STYLE, int WIDTH)
{
   ObjectDelete(name);                     
   ObjectCreate(name, OBJ_TREND,0,T1,P1,T2,P2);                     
   ObjectSet   (name, OBJPROP_COLOR, C);   
   ObjectSet   (name, OBJPROP_STYLE, STYLE);
   ObjectSet   (name, OBJPROP_WIDTH, WIDTH);
   ObjectSet   (name, OBJPROP_BACK,  true);
   ObjectSet   (name, OBJPROP_RAY,   false); 
}
//--------------------------------------------------------------------+


